unit EG;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExprDraw, ExprMake, Printers, Buttons;

type TArticle=record
               Title:string;
               Samples:array of string;
               Desc:string
              end;

  TFormGuide = class(TForm)
    ListBox: TListBox;
    Memo: TMemo;
    ScrollBox1: TScrollBox;
    Image: TImage;
    BtnPrint: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure BtnPrintClick(Sender: TObject);
   private
    Arts:array of TArticle;
    Index:Integer;
    procedure Add(Tlt,D:string;Smpls:array of string);
    procedure MakePict;
   public
  end;

var
  FormGuide: TFormGuide;

implementation

procedure TFormGuide.Add;
 var I:Integer;
  begin
   SetLength(Arts,Length(Arts)+1);
   with Arts[High(Arts)] do
    begin
     Title:=Tlt;
     Desc:=D;
     SetLength(Samples,Length(Smpls));
     for I:=Low(Smpls) to High(Smpls) do
      Samples[I]:=Smpls[I]
    end;
   I:=ListBox.Items.Add(Tlt);
   SendMessage(ListBox.Handle,LB_SetItemData,I,High(Arts))
  end;

{$R *.DFM}

procedure TFormGuide.FormCreate(Sender: TObject);
 begin
  Add(' ','    ,    .  -   ,      ( 1).'+'          ,   .        ,'+'    ,   - .   ,     .          ,'+'      .      ,     ( 2),    -  ( 3).          String'+'      ,  TExprBuilder.VarAutoIndex=True ( ),       ( 4).'+
                          '     ,        ( 5).'+
                          '         ( 6).    "e"  "E"     .'+'      .    -   ,    "#"   Num.',['Alpha, alpha','EnglEnc','','x12','beta0','1.234,0.7e9,1234678']);
  Add('','  ,         .    ,     .       .'+
                '      : E, E1, E2  . . -  , m, n, n1, n2  . . -  , R -  .       .'+
                '       ,     .  ,    ,  ,         ( 1).'+
                '       ,          ( 2).      ,      "!(" ( 3).'+
                '                  ( 4).'+
                ' ,     ,    ,  TExprBuilder.FuncAutoIndex=True ( ;  5).'+
                '       ,   ,    Nabla  PLambda.            ( 6).',['f(x,y,z)','cos(x), sin(pi/2+x), tg(1/x)','cos!(x)','f(x)_n,cos(x)^2','f0(x)=g1(x)','gamma0(x)']);
  Add('','   ,   ,  -  ,     ,  -  ,     .'+
                  '   1 "a"  "b+c/d" - , "b"  "c/d" - , "c"  "d" - .       :'+
                  #13#10'1.   (      "#",   '+
                  #13#10'2. ,   , ,    .'+
                  #13#10'3. .'+
                  #13#10'     "_",  , /  "+", "-", "+-", "-+",    .'+
                  '  TExBuilder.PostSymbols=True ( ),      "_", "^", "!"  "`".          "&"  .',['a=b+c/d','B_(2*k)=((-1)^(n-1)**2*(2*k)!/(2*pi)^(2*k))*summa(1/n^(2*k),n=1,inf)','line(u_i^2)=(2*plank^2/M/k/Theta)*((T^2/Theta^2)*int(x*diff(x)/(e^x-1),0,T//Theta)+1/4)','a0=(r2^2*(r2-3*r1)*V1(r1)-r1^2*(r1-3*r2)*V3(r2)-(r2*strokes(V1(r1))+r1*strokes(V3(r2)))*r1*r2*(r2-r1))/(r2-r1)^3','int(phi*cap(p)_x*psi*diff(x))=-i*plank*int(phi*pdiffrf(psi,x)*diff(x))=i*plank*int(psi*pdiffrf(phi,x)*diff(x))=int(psi*cap(p)_x^asterix*phi*diff(x))','grad(U)=lim(v->0,circ(U*diff(_S),Sigma)/v) & space(15) & div(_V)=lim(v->0,int(_V*diff(_S),Sigma)/v) & space(15) & rot(_V)=-lim(v->0,int(_V*+d*_S,Sigma)/v)','P(x)=summa(prod((x-x_j)/(x_i-x_j),standc(j=0,j<>i),n),i=0,n)']);
  Add(' ',' ,         ,  ,            "+".',['a&space(20)&b']);
  Add(' ...','.',['f(x1,x2,...,x_n)=0']);
  Add(' Alpha','  ',['Alpha','alpha']);
  Add(' Beta','  ',['Beta','beta']);
  Add(' Gamma','  ',['Gamma','gamma']);
  Add(' Delta','  ',['Delta','delta']);
  Add(' Epsilon','  ',['Epsilon','epsilon']);
  Add(' Zeta','  ',['Zeta','zeta']);
  Add(' Eta','  ',['Eta','eta']);
  Add(' Theta','  ',['Theta','theta']);
  Add(' Iota','  ',['Iota','iota']);
  Add(' Kappa','  ',['Kappa','kappa']);
  Add(' Lambda','  ',['Lambda','lambda']);
  Add(' Mu','  ',['Mu','mu']);
  Add(' Nu','  ',['Nu','nu']);
  Add(' Xi','  ',['Xi','xi']);
  Add(' Omicron','  ',['Omicron','omicron']);
  Add(' Pi','  ',['Pi','pi']);
  Add(' Rho','  ',['Rho','rho']);
  Add(' Sigma','  ',['Sigma','sigma']);
  Add(' Tau','  ',['Tau','tau']);
  Add(' Upsilon','  ',['Upsilon','upsilon']);
  Add(' Phi','  ',['Phi','phi']);
  Add(' Chi','  ',['Chi','chi']);
  Add(' Psi','  ',['Psi','psi']);
  Add(' Omega','  ',['Omega','omega']);
  Add(' Inf',' ',['lim(x->0,1/x)=+-Inf']);
  Add(' Plank','   ',['Plank=h/2/pi']);
  Add(' Nil',' ,   .  ,      ,     ,    .',['lim(nil,f(x))=0']);
  Add(' Comma','   .        ","   Comma.',['x&comma&y']);
  Add(' Const',' const,   .     ,   ,   .',['Int(x*Diff(x))=x^2/2+const']);
  Add(' Asterix',' "*",        .      .',['Summa(a_n*a_n^Asterix,n)=Int(Psi*Psi^Asterix*Diff(q))']);
  Add(' Minus',' "".      .   ("+", "="  . .)      String.'+'   String(-)   ,  ,    (  Unicode    -   ).',['a_Minus<>a_String(-)']);
  Add(' Parallel',' .',['_a & Parallel & _b','H_Parallel']);
  Add(' Perpendicular',' .',['_a & Perpendicular & _b','v_Perpendicular']);
  Add(' Angle',' ',['Angle**A']);
  Add(' Empty',' .    Nil,    ,     .',['Empty^2']);
  Add(' PLambda','   (   ).',['PLambda=lambda/2/pi']);
  Add(' Nabla',' "".',['Nabla*f=PDiffRF(f,x)*_e_x+PDiffRF(f,y)*_e_y+PDiffRF(f,z)*_e_z','Nabla*_a=PDiffRF(a_x,x)+PDiffRF(a_y,y)+PDiffRF(a_z,z)']);
  Add(' ()',' ,      .   ,         .       !().',['(x+1)*(y-2)','(x+1)/(x-1)','a+(b+c)=d*.(e*.f)','a*(b+c)<>d+(e*f)','y=(1+1/(1+1/x))']);
  Add(' !()','  ,     ,      .',['!(x+1)*!(y-2)','!(x+1)/!(x-1)','a+!(b+c)=d*.!(e*.f)','a*!(b+c)<>d+!(e*f)','y=!(1+1/!(1+1/x))']);
  Add(' []',' .    .',['[x+1]*[y-2]','[x+1]/[x-1]','a+[b+c]=d*.[e*.f]','a*[b+c]<>d+[e*f]','y=[1+1/[1+1/x]]']);
  Add(' {}',' .    .',['{x+1}*{y-2}','{x+1}/{x-1}','a+{b+c}=d*.{e*.f}','a*{b+c}<>d+{e*f}','y={1+1/{1+1/x}}']);
  Add(' ||',' .    .',['|x+1|*|y-2|','|x+1|/|x-1|','a+|b+c|=d*.|e*.f|','a*|b+c|<>d+|e*f|','y=|1+1/|1+1/x||']);
  Add(' "+"',' "",     ',['a+b']);
  Add(' "-"',' "",     ',['a-b']);
  Add(' "*"',' . ,       .  ,      ( 1).     ,      ( 2).'+'     ,      ( 3).          ,    ( 4)',['5*x','y*2','2*a*3','sin(x)*cos(x)']);
  Add(' "**"',' .       ,    .    .',['5**x','y**2','2**a**3','sin(x)**cos(x)']);
  Add(' "*."',' .      .    .',['5*.x','y*.2','2*.a*.3','sin(x)*.cos(x)']);
  Add(' "*+"',' .       .    .',['5*+x','y*+2','2*+a*+3','sin(x)*+cos(x)']);
  Add(' "<"','  ""',['a<b']);
  Add(' "<<"','  " "',['a<<b']);
  Add(' "<>"','  " "',['a<>b']);
  Add(' "<~"','  "  "',['a<~b']);
  Add(' "<="','  "  "',['a<=b']);
  Add(' ">"','  ""',['a>b']);
  Add(' ">>"','  " "',['a>>b']);
  Add(' ">~"','  "  "',['a>~b']);
  Add(' ">="','  "  "',['a>=b']);
  Add(' "="','  ""',['a=b']);
  Add(' "=="','  ""',['a==b']);
  Add(' "=~"','  "  "',['a=~b']);
  Add(' "~"','  ""',['a~b']);
  Add(' "~~"','  " "',['a~~b']);
  Add(' "-+','  "-"',['a-+b']);
  Add(' "+-"','  "-"',['a+-b']);
  Add(' "->"','  " "',['a->b']);
  Add(' "/"','  .       .   ,          ""'+'       ( 2).      ,      ( 3, 4  5)',['a/b','(x+1)/(x-1)*(x+2)/(x-2)/(x//y)*4','(1/2)*x','(3/4)*((x+1)/(x-1))','(3/4)*(x+1)/(x-1)']);
  Add(' "//"','  .   .       ( 2).       !() ( 3)',['a//b','x//(2*y)','x//!(2*y)']);
  Add(' "/+"','  .',['a/+b']);
  Add(' "&"  " & "','  .          ( 1),         ( 2)',['x&y','x & y']);
  Add(' "_" ()','    ,   .       .         Vect.',['_a']);
  Add(' "_" ( )','     .           ( 2).    '+'     Ind ( 3).   "_"        TExprBuilder.PostSymbols=True ( )',['a_b','a_x_0','Ind(a,Ind(x,0))']);
  Add(' "^"','         .          .         Pow.'+'       ( "_"   Ind),     ,   -  ( 2),        ( 3).'+'   "^"    TExprBuilder.PostSymbols=True ( )',['a^b','Ind(x,a)^2, x_a^2','Ind(x^2,a), x^2_a']);
  Add(' "`" ( )','   .          .       .'+'         Strokes.   "`"    TExprBuilder.PostSymbols=True ( )',['f(x)`','f(x)```']);
  Add(' "!"',' .   "!"       TExprBuilder.PostSymbols=True ( )',['C_n^k=n!/k!/(n-k)!']);
  Add(' ","',',     .       ,        ,     .      .',['a0,a1, a2,    a3']);
  Add(' "#"','     ,        .   1   2',['0.03*x','#0.03*x']);
  Add(' Sqrt',': Sqrt(E).     E.',['Sqrt(x^2+y^2)']);
  Add(' Sqr',': Sqr(E).   E  .          "^"   Pow.      ',['Sqr(a+b)=Sqr(a)+2*a*b+Sqr(b)']);
  Add(' Log',': Log(E1,E2).  E2   E1.',['log(a,x+1)=ln(x+1)/ln(a)']);
  Add(' Abs',': Abs(E).  E.        ||,      .',['Abs(x^2)=Abs(x)^2']);
  Add(' Pow',': Pow(E1,E2).  E1   E2.     Ind    Ind ( 2).        "^"',['Pow(x+2,2//3)','Pow(Ind(x,a),3)']);
  Add(' Root',': Root(E1,E2).    E1   E2.',['Root(3,x-1)']);
  Add(' Ind',': Ind(E1,E2).   E1     E2.        "_".     Pow    Pow ( 2).',['Ind(a,n)','Pow(Ind(x,n),2)=(Pow(Ind(x,n+1),2)+Pow(Ind(x,n-1),2))/2']);
  Add(' Lim',': Lim(E1,E2).   E2   E1.',['Lim(StandC(x->0,x>0),f(x))=1']);
  Add(' Func',': Func(E1,E2). , ""   E1,   - E2',['Func(PDiffRF(f,x,3),x)']);
  Add(' Space',': Space(n).    n  .    .',['y=x & space(7) & z=q']);
  Add(' Diff',': Diff(E1[,E2]).  E1  E2.',['Diff(x)','Diff(x,n)']);
  Add(' PDiff',': PDiff(E1[,E2]). " " E1  E2.      ""   ,          3',['PDiff(x)','PDiff(x,n)','PDiffN(f(x,y),3)/PDiff(x)/PDiff(y,2)']);
  Add(' DiffN',': DiffN(E1[,E2]).   E2  E1',['DiffN(x)','DiffN(x,n)']);
  Add(' PDiffN',': PDiffN(E1[,E2]). " "  E2  E1.      ""   ,          3',['PDiffN(x)','PDiffN(x,n)','PDiffN(f(x,y),3)/PDiff(x)/PDiff(y,2)']);
  Add(' DiffR',': DiffR(E1[,E2]).    E1  E2.',['DiffR(x)','DiffR(x,n)','DiffR(x,2)*f(x)=DiffR(x)*DiffR(x)*f(x)']);
  Add(' PDiffR',': PDiffR(E1[,E2]).    E1  E2.',['PDiffR(x)','PDiffR(x,n)','Nabla=PDiffR(x)*_e_x+PDiffR(y)*_e_y+PDiffR(z)*_e_z']);
  Add(' DiffRF',': DiffRF(E1,E2[,E3]).   E1  E2  E3.',['DiffRF(f,x)','DiffRF(f(x),x,n)']);
  Add(' PDiffRF',': PDiffRF(E1,E2[,E3]).   E1  E2  E3.',['PDiffRF(f,x)','PDiffRF(f(x,y),x,n)']);
  Add(' String',': String()  String(""). ,     .      ,       ',['String( )','String(" ( )")']);
  Add(' Strokes',': Strokes(E[,n]).   E ,   .',['Strokes(f(x))','Strokes(y,3)']);
  Add(' Fact',': Fact(E).  E.     "!"  E.',['Fact(n)','Fact(k+1)']);
  Add(' At',': At(E1,E2).  E1   E2.',['At(DiffRF(f,x),x=0)=1']);
  Add(' Line',': Line(E).    E.',['Line(x)','Line(x^2)']);
  Add(' Vect',': Vect(E).  ()  E.         "_"  E.',['Vect(a)']);
  Add(' Cap',': Cap(E).  ""  E.',['Cap(x)']);
  Add(' Tilde',': Tilde(E).    E.',['Tilde(x)']);
  Add(' Points',': Points(E[,n]).   E,     .',['Points(y,2)=y*Points(x)']);
  Add(' StandL',': StandL(E[,...]).      ,    .',['StandL(0<=i<n,i<>j)']);
  Add(' StandR',': StandR(E[,...]).      ,    .',['StandR(0<=i<n,i<>j)']);
  Add(' StandC',': StandC(E[,...]).      ,   .',['StandC(0<=i<n,i<>j)']);
  Add(' Matrix',': Matrix(n,m,E[,...]).   n  m.  E        .    ,  n*m -       .'+'    ,    ',['Matrix(2,3,x,y,x-y,x+y,z,z+y)','!(Matrix(2,2,1,2,-3,4))','[_a,_b]=|Matrix(3,3,_e_x,_e_y,_e_z,x_a,y_a,z_a,x_b,y_b,z_b)|']);
  Add(' Summa',': Summa(E1[,E2[,E3]]).   E1.     E2,   - E3.',['Summa(a_i)','Summa(a_i,i<>j)','Summa(a_i,i=0,n)']);
  Add(' Prod',': Prod(E1[,E2[,E3]]).   E1.     E2,   - E3.',['Prod(a_i)','Prod(a_i,i<>j)','Prod(a_i,i=0,n)']);
  Add(' Circ',': Circ(E1[,E2[,E3]]).   E1.     E2,   - E3.',['Circ(_E*Diff(_l),L)']);
  Add(' Int',': Int(E1[,E2[,E3]]).   E1.     E2,   - E3.',['F(x)=Int(f(x)*Diff(x))','Phi=Int(_H*Diff(_S),S)','Int(x,0,1)=1']);
  Add(' IntM',': IntM(n,E1[,E2[,E3]]). n-   E1.     E2,   - E3.  n<=0,      ( ).',['IntM(3,f(x,y,z)*Diff(x)*Diff(y)*Diff(z),V)','IntM(0,f(x1,...,x_n)*DiffN(x,n))']);
  Add(' Case',': Case(E[,...]).     .        -.',['|x|=Case(-x,x<0,0,x=0,x,x>0)']);
  Add(' Comma',': Comma(n).    ,    -    n  .',['x & comma(15) & y']);
  Add(' Brackets',': Brackets(S1S2,E).  E   .   S1    "(", "[", "{", "|"  "0",   S2 - ")", "]", "}", "|"  "0" ("0"      ).',['Brackets((],0&comma&1)']);
  Add(' System',': System(E[,...]).    .',['System(x+y=5,x*y=6)']);
  Add(' Num',': Num(R[,n1[,n2[,n3]]]).      R.       -n3,      n1,   -     '+'   n1   n2.   n1=4, n2=4, n3=2',['Num(0.00123456)','Num(0.00123456, 6)','Num(0.00123456, 4, 4, 3)','Num(0.00123456, 4, 6, 3)']);
  Add(' Symbol',': Symbol(n).       n   Unicode.',['Symbol(198)=1']);
  Add(' Angle',': Angle()  Angle("").     .     ,     .',['Angle(ABC)']);
  ListBox.ItemIndex:=0;
  ListBoxClick(Self)
 end;

procedure TFormGuide.ListBoxClick(Sender: TObject);
 begin
  Index:=SendMessage(ListBox.Handle,LB_GetItemData,ListBox.ItemIndex,0);
  Memo.Text:=Arts[Index].Desc;
  MakePict
 end;

procedure TFormGuide.MakePict;
 var I:Integer;
     Expr:TExprClass;
     DY:Integer;
     Builder:TExprBuilder;
     MX:Integer;
  begin
   with Image.Picture.Bitmap do
    begin
     Width:=2000;
     Height:=1000;
     Canvas.Brush.Style:=bsSolid;
     Canvas.Brush.Color:=clInfoBk;
     Canvas.FillRect(Rect(0,0,Width,Height))
    end;
   DY:=5;
   MX:=0;
   Builder:=TExprBuilder.Create;
   for I:=0 to High(Arts[Index].Samples) do
    begin
     Expr:=TExprVar.Create(' '+IntToStr(I+1)+': ');
     Expr.Color:=clBlue;
     Expr.AddNext(TExprSimple.Create(Arts[Index].Samples[I]));
     Expr.AddNext(TExprVar.Create(' : '));
     Expr.Next.Next.Color:=clBlue;
     Expr.AddNext(Builder.BuildExpr(Arts[Index].Samples[I]));
     Expr:=TExprChain.Create(Expr);
     Expr.Canvas:=Image.Picture.Bitmap.Canvas;
     Expr.Font.Size:=11;
     Expr.Draw(5,DY,ehLeft,evTop);
     Inc(DY,Expr.Height+5);
     if MX<Expr.Width then
      MX:=Expr.Width;
     Expr.Free
    end;
   Builder.Free;
   Image.Picture.Bitmap.Width:=MX+10;
   Image.Picture.Bitmap.Height:=DY;
   Image.Width:=MX+10;
   Image.Height:=DY
  end;

procedure TFormGuide.BtnPrintClick(Sender: TObject);
 var I,J,TH,AH,PH,PW,DX,DY,CY,Index:Integer;
     R:TRect;
     VP,HP:Extended;
     Expr,Expr2:TExprClass;
     Builder:TExprBuilder;
  begin
   with Printer do
    begin
     BeginDoc;
     SetBkMode(Canvas.Handle,Transparent);
     VP:=GetDeviceCaps(Canvas.Handle,LogPixelSY)/2.54;
     HP:=GetDeviceCaps(Canvas.Handle,LogPixelSX)/2.54;
     DX:=Round(VP);
     PW:=Printer.PageWidth-2*DX;
     DY:=Round(1.5*HP);
     PH:=Printer.PageHeight-DY;
     CY:=DY;
     Builder:=TExprBuilder.Create;
     for I:=0 to ListBox.Items.Count-1 do
      begin
       Index:=SendMessage(ListBox.Handle,LB_GetItemData,I,0);
       Canvas.Font.Name:='Times New Roman';
       Canvas.Font.Charset:=Russian_Charset;
       Canvas.Font.Style:=[fsBold];
       Canvas.Font.Size:=13;
       R:=Rect(DX,CY,DX+PW,PH);
       DrawText(Canvas.Handle,PChar(Arts[Index].Title),-1,R,DT_CalcRect or DT_Center or DT_Top or DT_WordBreak or DT_NoPrefix);
       TH:=R.Bottom-R.Top;
       Canvas.Font.Name:='Arial';
       Canvas.Font.Charset:=Russian_Charset;
       Canvas.Font.Style:=[];
       Canvas.Font.Size:=11;
       R:=Rect(DX,CY,DX+PW,PH);
       DrawText(Canvas.Handle,PChar(Arts[Index].Desc),-1,R,DT_CalcRect or DT_Left or DT_Top or DT_WordBreak or DT_NoPrefix);
       AH:=R.Bottom-R.Top;
       if CY+TH+AH>PH then
        begin
         NewPage;
         CY:=DY;
         SetBkMode(Canvas.Handle,Transparent)
        end;
       Canvas.Font.Name:='Times New Roman';
       Canvas.Font.Style:=[fsBold];
       Canvas.Font.Size:=13;
       R:=Rect(DX,CY,DX+PW,PH);
       DrawText(Canvas.Handle,PChar(Arts[Index].Title),-1,R,DT_Center or DT_Top or DT_WordBreak or DT_NoPrefix);
       Inc(CY,TH);
       Canvas.Font.Name:='Arial';
       Canvas.Font.Style:=[];
       Canvas.Font.Size:=11;
       R:=Rect(DX,CY,DX+PW,PH);
       DrawText(Canvas.Handle,PChar(Arts[Index].Desc),-1,R,DT_Left or DT_Top or DT_WordBreak or DT_NoPrefix);
       Inc(CY,AH);
       for J:=0 to High(Arts[Index].Samples) do
        begin
         Expr:=TExprCustomText.Create(' '+IntToStr(J+1)+': ');
         Expr.AddNext(TExprSimple.Create(Arts[Index].Samples[J]));
         Expr.AddNext(TExprCustomText.Create('  : '));
         Expr.AddNext(Builder.BuildExpr(Arts[Index].Samples[J]));
         Expr:=TExprChain.Create(Expr);
         Expr.Canvas:=Canvas;
         Expr.Font.Size:=11;
         if Expr.Width>PW then
          begin
           Expr.Free;
           Expr:=TExprCustomText.Create(' '+IntToStr(J+1)+': ');
           Expr.AddNext(TExprSimple.Create(Arts[Index].Samples[J]));
           Expr:=TExprChain.Create(Expr);
           Expr2:=TExprCustomText.Create(': ');
           Expr2.AddNext(Builder.BuildExpr(Arts[Index].Samples[J]));
           Expr.AddNext(TExprChain.Create(Expr2));
           Expr:=TExprStand.Create(Expr,ehLeft);
           Expr.Canvas:=Canvas;
           Expr.Font.Size:=11;
           while Expr.Width>PW do
            Expr.Font.Size:=Expr.Font.Size-1
          end;
         if CY+Expr.Height>PH then
          begin
           NewPage;
           CY:=DY
          end;
         Expr.Draw(DX,CY,ehLeft,evTop);
         Inc(CY,Expr.Height+Round(0.2*HP));
         Expr.Free
        end
      end;
     Builder.Free;
     EndDoc
    end
  end;

end.
